[tool.black]
line-length = 80
target-version = ["py311"]

[tool.pylint.main]
init-hook = 'import sys; sys.path.append("."); sys.path.append("./src")'
load-plugins = ["pylint.extensions.bad_builtin", "pylint.extensions.mccabe"]
include-naming-hint = true
good-names = ["E", "oc", "gl", "f", "n", "k", "v", "e"]

[tool.pylint.reports]
output-format = "colorized"
msg-template="{path}:{line}: [{symbol}:{obj}] {msg}"

[tool.pylint.format]
max-line-length = 80

[tool.pylint.design]
max-args=7
max-complexity = 7
min-public-methods = 0
max-public-methods = 40

[tool.pylint."messages control"]
confidence = []
disable = ["missing-docstring", "logging-format-interpolation", "logging-fstring-interpolation"]

[tool.pytest.ini_options]
addopts = [
    "--import-mode=importlib",
]
pythonpath = "."

[tool.pyright]
typeCheckingMode = "strict"
pythonPlatform = "Linux"

[tool.ruff]
select = ["F", "E", "W", "C90", "N", "UP", "B", "A", "PL", "C4", "EXE", "ISC", "PIE", "T20", "PT", "RET", "SIM", "TCH",
    "PTH", "PLR", "PLW", "ARG", "ERA", "RUF", "Q"]
ignore = [
    "A003",
    "ERA001",
    "RUF001",
    "RUF002",
    "RUF003",
    "UP007",
    "E501",
    "N999",
]
fixable = ["F", "E", "W", "C90", "N", "UP", "B", "A", "PL", "C4", "EXE", "ISC", "PIE", "T20", "PT", "RET", "SIM", "TCH",
    "PTH", "PLR", "PLW", "ARG", "ERA", "RUF", "Q"]
exclude = [
    ".git",
    ".ruff_cache",
    "resources",
    "docs",
    "src/dashboard.py",
]
line-length = 80
target-version = "py311"

[tool.ruff.lint.mccabe]
max-complexity = 15

[tool.ruff.lint.pylint]
max-returns = 15

[tool.isort]
profile = "black"
py_version=311
line_length=80

[tool.mypy]
cache_dir = ".mypy_cache/"
check_untyped_defs = true
disallow_incomplete_defs = true
disallow_untyped_decorators = true
disallow_untyped_defs = false
enable_error_code = "ignore-without-code"
follow_imports = "normal"
files = ["src/**/*.py", "tests/**/*.py"]
ignore_missing_imports = false
install_types = true
non_interactive = true
pretty = true
python_version = 3.11
show_column_numbers = true
show_error_codes = true
show_error_context = true
strict_equality = true
strict_optional = true
warn_redundant_casts = true
warn_unreachable = true
warn_unused_ignores = true
